SystemOrganization addCategory: #'acceptit-Compiler'!
SystemOrganization addCategory: #'acceptit-Core-Model'!
SystemOrganization addCategory: #'acceptit-Tests'!
SystemOrganization addCategory: #'acceptit-Tests-Fixtures'!
(PackageInfo named: 'acceptit') postscript: '"below, add code to be run after the loading of this package"
ACUserStory named: #AName
	purpose: ''impress the ladies''
	role: ''Casanova''
	means: ''Prosecco'''!

WAComponent subclass: #ACTestRootComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Fixtures'!

!ACTestRootComponent class methodsFor: 'as yet unclassified' stamp: 'topa 6/9/2010 12:49'!
canBeRoot

^true! !

!ACTestRootComponent class methodsFor: 'as yet unclassified' stamp: 'topa 6/9/2010 13:01'!
registerApplication

^WAAdmin 
		register: self
		asApplicationAt: 'ACTest'.! !

!ACTestRootComponent methodsFor: 'as yet unclassified' stamp: 'topa 6/9/2010 12:46'!
renderContentOn: html
 "I render everything by calling html"

	html text: 'Hello World'.! !

OMeta2 subclass: #ACParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACParser methodsFor: 'helpers' stamp: 'topa 5/18/2010 18:05'!
charNoNewline =

	<char:x ?[x ~= Character cr]>! !

!ACParser methodsFor: 'parsing' stamp: 'topa 6/3/2010 15:11'!
endOfLastToken

	^ 'scenario1' size! !

!ACParser methodsFor: 'scenario-rules' stamp: 'topa 5/27/2010 14:55'!
givenLine =

	 spaces <``Given''> spaces <charNoNewline+>:body -> [{#given . body}]! !

!ACParser methodsFor: 'helpers' stamp: 'topa 5/18/2010 17:51'!
lineEnd =

	<char:x ?[x = Character cr]>! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/20/2010 09:39'!
meansLine =

	spaces <``I want'' `` to''?> spaces <charNoNewline+>:body -> [{#means . body}]! !

!ACParser methodsFor: 'parsing' stamp: 'topa 6/3/2010 15:10'!
parseSelector: aByteString 
	^ 'scenario1'! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/19/2010 13:02'!
purposeLine =

	 spaces <``In order to''> spaces <charNoNewline+>:body -> [{#purpose . body}]! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/19/2010 13:02'!
roleLine =

		 spaces <``As a'' ``n''?> spaces <charNoNewline+>:body -> [{#role . body}]! !

!ACParser methodsFor: 'scenario-rules' stamp: 'topa 5/27/2010 14:54'!
scenario =

	givenLine:given lineEnd
	whenLine:when lineEnd
	thenLine:then lineEnd? end -> [{#scenario. given. when. then}]
	! !

!ACParser methodsFor: 'helpers' stamp: 'topa 5/20/2010 09:59'!
space =
	// we do not allow newline as whitespace
	
	^space:s ?[ ({Character cr. Character lf} noneSatisfy: [:c | c =s ])]! !

!ACParser methodsFor: 'scenario-rules' stamp: 'topa 5/27/2010 14:55'!
thenLine =

	 spaces <``Then''> spaces <charNoNewline+>:body -> [{#then . body}]! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/19/2010 13:02'!
title =

	<charNoNewline+>:body -> [{#title . body}]! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/20/2010 10:03'!
userStory =
	
	title:t lineEnd+
	purposeLine:purpose lineEnd
	roleLine:role lineEnd
	meansLine:means lineEnd? end -> [{#userStory. t. purpose. role. means}]
	! !

!ACParser methodsFor: 'scenario-rules' stamp: 'topa 5/27/2010 14:55'!
whenLine =

	 spaces <``When''> spaces <charNoNewline+>:body -> [{#when . body}]! !

OMeta2 subclass: #ACTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:27'!
messagePart =

	{symbol:s string:body} -> ['	', s asMutator,' ''', body,'''', String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:21'!
rule =

	{symbol:s string:body} -> ['	self ', s asMutator,' ''', body,'''.', String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:35'!
title =

	{symbol:t string:s} -> ['ACUserStory named: ', s asLegalSelector capitalized asSymbol printString, String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:27'!
translate =
	
	{symbol:type ?[type = #userStory] title:t messagePart:purpose messagePart:role messagePart:means}
		-> [t, purpose, role, means]
|	{symbol:type ?[type = #scenario] rule:given rule:when rule:then}
		-> ['scenario1', String cr, given, when, then]! !

Compiler subclass: #ACCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:18'!
compile: origCode in: cls classified: aCategory notifying: notify ifFail: failBlock

	^ self compile: origCode in: cls notifying: notify ifFail: failBlock! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'fg 6/11/2010 11:01:03.933'!
compile: origCode in: cls notifying: notify ifFail: failBlock

	| origCodeStream translatedCode |
	origCodeStream := origCode asString readStream.
	self from: origCodeStream class: cls context: nil notifying: notify.
	[ | parseTree |		
		parseTree := self parserClass matchStream: origCodeStream with: #scenario withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #translate.
	] on: OM2Fail do: [:ignore |
		self notify: '<-- parse error around here -->' at: origCodeStream position.
		^ failBlock value
	].
	^ Compiler new
		compile: translatedCode readStream
		in: cls
		notifying: notify
		ifFail: failBlock! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:24'!
parse: aStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock

	^ [
		| parseTree translatedCode code |
		parseTree := self parserClass matchStream: aStream with: #userStory withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #translate.
		Parser new parse: translatedCode readStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock
	] on: OM2Fail do: [aBlock value]! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:31'!
parserClass

	^ ACParser! !

TestCase subclass: #ACCompilerScenarioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACCompilerScenarioTest methodsFor: 'as yet unclassified' stamp: 'fg 6/11/2010 14:07:55.746'!
testScenarioCompilation

	|scenario acMethod stMethod scenarioDecompiled |
	scenario := 'Given I have a web site
				When I go to the web site
				Then I see "Hello World"'.
	
	scenarioDecompiled := 'scenario1
		self given: ''I have a web site''.
		self when: ''I go to the web site''.
		self then: ''I see "Hello World"''.'.
	
	acMethod := ACCompiler new compile:  scenario  in: self class classified: nil notifying: nil ifFail: [].
	stMethod := Compiler new compile: scenarioDecompiled in: self class classified: nil notifying: nil ifFail: [].

	self 
		should: [acMethod selector = stMethod selector];
		should: [acMethod decompileString = stMethod decompileString].! !

TestCase subclass: #ACCompilerUserStoryTest
	instanceVariableNames: 'klassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 6/3/2010 14:07'!
directClassWithVariablesSet

	| theKlass |
	theKlass := (ACUserStory subclass: self klassName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: ACUserStory category).
	^ theKlass purpose: 'impress the ladies'; role: 'Casanova'; means: 'Prosecco'.! !

!ACCompilerUserStoryTest methodsFor: 'accessing' stamp: 'topa 6/3/2010 13:55'!
klassName

	^ klassName! !

!ACCompilerUserStoryTest methodsFor: 'accessing' stamp: 'topa 6/3/2010 13:55'!
klassName: anObject

	klassName := anObject! !

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 6/3/2010 14:01'!
parseTree

	^ ACTranslator match: (ACParser matchStream: 
'A Name For Testing
In order to impress the ladies
As a Casanova
I want Prosecco
' readStream with: #userStory withArgs: #() withPlaybackDebugging: false) with: #translate! !

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 6/3/2010 14:08'!
removeTestClass

	self klassName ifNotNilDo: [:name | 
		(Smalltalk globals at: name ifAbsent: [^ self]) removeFromSystemUnlogged].! !

!ACCompilerUserStoryTest methodsFor: 'running' stamp: 'topa 6/3/2010 13:57'!
setUp

	self klassName: #ANameForTesting.! !

!ACCompilerUserStoryTest methodsFor: 'running' stamp: 'topa 6/3/2010 14:02'!
tearDown

	self removeTestClass.! !

!ACCompilerUserStoryTest methodsFor: 'testing' stamp: 'fg 6/11/2010 14:16:34.89'!
testUserStoryCompilation

	| direct indirect generated |
	direct := self directClassWithVariablesSet definition.
	self removeTestClass.
	indirect := (ACUserStory named: self klassName
		purpose: 'impress the ladies' 
		role: 'Casanova'
		means: 'Prosecco') definition.
	self removeTestClass.
	generated := (Compiler evaluate: self parseTree notifying: nil logged: false) definition.
	self removeTestClass.
	
	self 
		should: [direct = indirect];
		should: [indirect = generated].! !

TestCase subclass: #ACParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

ACParserTest subclass: #ACParserScenarioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:09:29.211'!
testScenarioGiven

|given|
given:= 'Given I have a web site'.

		self should: [self match: given with: #givenLine].	! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:35:50.72'!
testScenarioInvalidNewlinesMatch

|scenarioInvalidNewlines|
	
	scenarioInvalidNewlines := 'Given I have a web site
	
		When I go to the web site
		
		Then I see "Hello World"'.
	self shouldnt: [self match:  scenarioInvalidNewlines with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:12:03.478'!
testScenarioInvalidOrderMatch

|scenarioInvalidOrder|

	scenarioInvalidOrder:= 'When I go to the web site
		Given I have a web site
		Then I see "Hello World"'.
	self shouldnt: [self match: scenarioInvalidOrder with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:12:51.013'!
testScenarioInvalidSyntaxMatch
|scenarioInvalidSyntax|

	scenarioInvalidSyntax:= 'Gvien I have a web site
		Wehn I go to the web site
		Tehn I see "Hello World"'.
	self shouldnt: [self match: scenarioInvalidSyntax with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:13:37.893'!
testScenarioInvalidTrailersMatch

|scenarioInvalidTrailers|
scenarioInvalidTrailers:= 'Given I have a web site
	When I go to the web site
	Then I see "Hello World"
	Yes, This would be awesome.'.
	
	self shouldnt: [self match: scenarioInvalidTrailers with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:14:28.981'!
testScenarioMatch
|scenario|

	scenario:= 'Given I have a web site
	When I go to the web site
	Then I see "Hello World"'.
	self should: [self match: scenario with: #scenario].
! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:15:31.495'!
testScenarioThen
	
	|then|
	then := 'Then I see "Hello World"'.
	
	self should: [self match: then with: #thenLine].	! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:16:08.326'!
testScenarioWhen

	|when|
	when:= 'When I go to the web site'.
	self should: [self match: when with: #whenLine].	! !

!ACParserTest class methodsFor: 'as yet unclassified' stamp: 'topa 5/27/2010 14:50'!
isAbstract

	^ self == ACParserTest! !

!ACParserTest methodsFor: 'helpers' stamp: 'topa 5/27/2010 14:48'!
match: aString with: aRule

	[ACParser matchAll: aString with: aRule]
		on: OM2Fail
		do: [^ false].
	^ true! !

ACParserTest subclass: #ACParserUserStoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:36:39.815'!
testUserStoryInvalidNewlinesMatch

	|userStoryInvalidNewlines|
	userStoryInvalidNewlines :='A Title
		In order to achieve something
		
		As a role
		
		I want to do something.'.
	self shouldnt: [self match: userStoryInvalidNewlines with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:18:37.474'!
testUserStoryInvalidOrderMatch

	|userStoryInvalidOrder|
	userStoryInvalidOrder := 'A Title
		As a role
		I want to do something
		In order to achieve something.'.
	self shouldnt: [self match: userStoryInvalidOrder with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:19:35.46'!
testUserStoryInvalidSyntaxMatch

	|userStoryInvalidSyntax|
	userStoryInvalidSyntax := 'A Title
		In roder to achieve something
		Asa role
		I wnat ot do something.'.
	self shouldnt: [self match: userStoryInvalidSyntax with: #userStory].
	self flag: #extend. "topa: should look for position of invalid syntax"! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:20:19.864'!
testUserStoryInvalidTrailersMatch

	|userStoryInvalidTrailers|
	userStoryInvalidTrailers := 'A Title
		In order to achieve something
		As a role
		I want to do something.
	
		This is cool
		'.
	self shouldnt: [self match: userStoryInvalidTrailers with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:21:18.908'!
testUserStoryMatch

	|userStory|
	userStory := 'A Title
		In order to achieve something
		As a role
		I want to do something.'.
	self should: [self match: userStory with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:22:37.873'!
testUserStoryMeansMatch

	|means|
	means:= 'I want to do something.'.
	self should: [self match: means with: #meansLine].	! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:23:49.879'!
testUserStoryMeansOptionalToMatch

	|meansOptionalTo|
	meansOptionalTo := 'I want a cake.'.
	self should: [  self match: meansOptionalTo with: #meansLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:24:39.316'!
testUserStoryMeansOptionalToWithAnMatch

|meansOptionalToWithAn|
	meansOptionalToWithAn :='I want an embedded sleeping hour.'.
	self should: [  self match: meansOptionalToWithAn with: #meansLine].! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:26:24.557'!
testUserStoryMissingArgsMatch

	|userStoryMissingArgs|
	userStoryMissingArgs := 'A Title
		In order to
		As a
		I want'.
	self shouldnt: [self match: userStoryMissingArgs with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:27:38.785'!
testUserStoryNewlineAfterTitleMatch
	
	|userStoryNewlineAfterTitle|
	userStoryNewlineAfterTitle := 'A Title

		In order to achieve something
		As a role
		I want to do something.'.
	self should: [self match:  userStoryNewlineAfterTitle with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:28:44.094'!
testUserStoryPurposeMatch

	|purpose|
	purpose := 'In order to achieve something.'.
	self should: [  self match: purpose with: #purposeLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:29:30.091'!
testUserStoryRoleMatch

	|role|
	role :=  'As a role'.
	self should: [ self match: role with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:30:09.156'!
testUserStoryRoleWithAnMatch

	|roleWithAn|
	roleWithAn := 'As an emancipated role'.
	self should: [ self match: roleWithAn with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:30:47.067'!
testUserStoryRoleWithPluralMatch
	
	|roleWithPlural|
	roleWithPlural:='As roles'.
	self shouldnt: [ self match: roleWithPlural with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:31:33.05'!
testUserStorySpacingMatch
	
	|userStorySpacing|
	userStorySpacing := 
	'A Title
	    In order to achieve something
		As a role
	 	 I want to do something.'.
	self should: [self match: userStorySpacing with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/19/2010 12:22'!
testUserStoryTitleMatch

	self should: [self match: 'A Title' with: #title].	! !

TestCase subclass: #ACTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:40'!
testGivenTranslation

	|pt sourceCode|
	
	pt:= #(given 'I have a web site').
	sourceCode:= '	self given: ''I have a web site''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:39'!
testMeansTranslation

	| pt |
	pt:= #(means 'do something.').
	self should: (ACTranslator match: pt with: #messagePart) = ('	means: ''do something.''', String cr).! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:40'!
testPurposeTranslation

	| pt |
	pt:= #(purpose 'achieve something').
	self should: (ACTranslator match: pt with: #messagePart) = ('	purpose: ''achieve something''', String cr).
	! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:41'!
testRoleTranslation

	| pt |
	pt:= #(role 'role').
	self should: (ACTranslator match: pt with: #messagePart) = ('	role: ''role''', String cr).! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:52'!
testScenarioTranslation

	|pt sourceCode|
	
	pt:= #(scenario 
		#(given 'I have a web site') 
		#(when 'I go to the web site') 
		#(then 'I see "Hello World"')).
	sourceCode:= 'scenario1
	self given: ''I have a web site''.
	self when: ''I go to the web site''.
	self then: ''I see "Hello World"''.', String cr.
	self should: (ACTranslator match: pt with: #translate) = sourceCode.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:45'!
testThenTranslation

	|pt sourceCode|
	
	pt:= #(then 'I see "Hello World"').
	sourceCode:= '	self then: ''I see "Hello World"''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:42'!
testTitleTranslation

	| pt |
	pt:= #(title 'A Title').
	self should: (ACTranslator match: pt with: #title) = ('ACUserStory named: #ATitle', String cr).! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:33'!
testUserStoryTranslation

	| pt |
	pt:= #(userStory
		#(title 'A Title') 
		#(purpose 'achieve something') 
		#(role 'role') 
		#(means 'do something.')).
	self should: (ACTranslator match: pt with: #translate) = ACTestResource userStoryDecompiled.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:40'!
testWhenTranslation

	|pt sourceCode|
	
	pt:= #(when 'I go to the web site').
	sourceCode:= '	self when: ''I go to the web site''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

TestCase subclass: #ACUserStory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Model'!

ACUserStory class
	instanceVariableNames: 'purpose role means'!

ACUserStory class
	instanceVariableNames: 'purpose role means'!

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'db 6/7/2010 14:22'!
allTestSelectors

	^#(#scenario1)
			! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/9/2010 14:08'!
compilerClass
	"remove when changing the class!!"
		
	^ "("
	(self == ACUserStory) "or: [
		(thisContext sender method selector == #recompile:from:) and: [
			self == (thisContext sender at: 2) 
			"
			"old class during recompile"
			"]])"
		ifTrue: [super compilerClass]
		ifFalse: [ACCompiler]! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:16'!
definition

	^ self == ACUserStory
		ifTrue: [super definition]
		ifFalse: [String streamContents: [:stream |
			stream
				nextPutAll: (super definition findTokens: ' ') first "superClass"; space;
				nextPutAll: 'named: '; nextPutAll: self name printString; crtab;
				nextPutAll: 'purpose: '; nextPutAll: self purpose printString; crtab;
				nextPutAll: 'role: '; nextPutAll: self role printString; crtab;
				nextPutAll: 'means: '; nextPutAll: self means printString]]! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:23'!
isAbstract

	^ self == ACUserStory! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
means

	^means! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
means: anObject

	means := anObject! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 12:48'!
named: aNameSymbol
purpose: purposeString
role: roleString
means: meansString

	|klass|		
	klass := self subclass: aNameSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self category.
	klass purpose: purposeString; role: roleString; means: meansString.
	
	^ klass! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/8/2010 14:03'!
newFrom: anObject

	(anObject isKindOf: String)
		ifTrue: [^ self userStoryFromString: anObject].

	^ super newFrom: anObject! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/8/2010 14:47'!
parserClass

	self == ACUserStory
		ifFalse: [
			 ((thisContext client isKindOf: Browser) and: [
				thisContext sender selector = #validateMessageSource:forSelector:])
					ifTrue: [^ACParser]].
	^ super parserClass
! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
purpose

	^purpose! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
purpose: anObject

	purpose := anObject! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
role

	^role! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
role: anObject

	role := anObject! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/8/2010 14:04'!
userStoryFromString: anObject

	^ Compiler 
		evaluate: (ACTranslator 
			match: (ACParser matchAll: anObject readStream with: #userStory withArgs: #()) 
			with: #translate)
		notifying: nil 
		logged: true! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'fg 6/10/2010 09:39'!
given: aString

	(aString = 'I have a web site')
		ifTrue: [
			WAKom startOn: 9999. 
			ACTestRootComponent registerApplication.
			(Delay forMilliseconds: 500) wait].! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'fg 6/10/2010 09:36'!
tearDown

	| adaptor |
	"WAAdmin unregister: 'ACTest'."
	WADispatcher default unregister: 'ACTest'.
	adaptor := WAAdmin serverAdaptors detect: [:a | a port = 9999] ifNone: [nil].
	adaptor ifNotNil: [:a|
		a isRunning ifTrue: [ a stop ]].! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'topa 6/9/2010 14:20'!
then: aString

	|temp|
	temp := self instVarNamed: 'result'.
	( aString = 'I see "Hello World"')
		ifTrue: [
			self assert: (temp includesSubString: 'Hello World')]
	! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'topa 6/9/2010 14:20'!
when: aString

	(aString = 'I go to the web site')
		ifTrue: [self instVarNamed: 'result' put: (HTTPClient httpGet: 'http://localhost:9999/ACTest') contents].! !

ACUserStory subclass: #AName
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Model'!

!AName methodsFor: 'as yet unclassified' stamp: 'fg 6/10/2010 09:35'!
Given I have a web site
When I go to the web site
Then I see "Hello World"
! !

TestCase subclass: #ACUserStoryTest
	instanceVariableNames: 'klassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACUserStoryTest methodsFor: 'as yet unclassified' stamp: 'fg 6/10/2010 19:57:56.355'!
removeTestClass: clsName

	clsName ifNotNilDo: [:name |
		(Smalltalk globals at: name ifAbsent: [^ self]) removeFromSystemUnlogged].! !

!ACUserStoryTest methodsFor: 'as yet unclassified' stamp: 'fg 6/11/2010 11:23:08.73'!
testUserStoryCreation

	| userStory userStoryTestClass userStoryName acMethod compiledMethod |
	
	userStory := 'MyTestClass
		In order to deal with UserStories
		As a developer
		I want generated classes from Userstories'.
		
	userStoryTestClass := ACUserStory newFrom: userStory .
	userStoryName := userStoryTestClass name.
	
	"Test if the generated class inherits fromt TestCase"
	self assert: userStoryTestClass superclass superclass  equals: TestCase.
	acMethod := ACCompiler new
		compile: ACTestResource scenario 
		in: userStoryTestClass
		classified: nil
		notifying: nil
		ifFail: [].
	compiledMethod := acMethod generate.
	userStoryTestClass addSelector: compiledMethod selector withMethod: compiledMethod. 
		"remove the generated classes"
	self assert: userStoryTestClass methodDict keys size equals: 1.
	self assert: userStoryTestClass methodDict keys first equals: compiledMethod selector.
	self removeTestClass: (userStoryName asSymbol).! !

Object subclass: #ACTestResourceOld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Fixtures'!

!ACTestResourceOld class methodsFor: 'strings-given' stamp: 'topa 5/27/2010 14:59'!
given

	^ 'Given I have a web site'! !

!ACTestResourceOld class methodsFor: 'strings-means' stamp: 'topa 5/20/2010 09:36'!
means

	^ 'I want to do something.'! !

!ACTestResourceOld class methodsFor: 'strings-means' stamp: 'topa 5/20/2010 09:36'!
meansOptionalTo

	^ 'I want a cake.'! !

!ACTestResourceOld class methodsFor: 'strings-means' stamp: 'topa 5/20/2010 09:37'!
meansOptionalToWithAn

	^ 'I want an embedded sleeping hour.'! !

!ACTestResourceOld class methodsFor: 'strings-purpose' stamp: 'topa 5/20/2010 09:36'!
purpose

	^ 'In order to achieve something.'! !

!ACTestResourceOld class methodsFor: 'strings-role' stamp: 'topa 5/20/2010 09:43'!
role

	^ 'As a role'! !

!ACTestResourceOld class methodsFor: 'strings-role' stamp: 'topa 5/20/2010 09:43'!
roleWithAn

	^ 'As an emancipated role'! !

!ACTestResourceOld class methodsFor: 'strings-role' stamp: 'topa 5/20/2010 09:44'!
roleWithPlural

	^ 'As roles'! !

!ACTestResourceOld class methodsFor: 'strings-Scenario-valid' stamp: 'topa 5/27/2010 14:51'!
scenario

	^
'Given I have a web site
When I go to the web site
Then I see "Hello World"'! !

!ACTestResourceOld class methodsFor: 'strings-Scenario-valid' stamp: 'topa 6/3/2010 11:01'!
scenarioDecompiled

	^
'scenario1
	self given: ''I have a web site''.
	self when: ''I go to the web site''.
	self then: ''I see "Hello World"''.'! !

!ACTestResourceOld class methodsFor: 'strings-Scenario-invalid' stamp: 'topa 5/27/2010 15:03'!
scenarioInvalidNewlines

	^
'Given I have a web site

When I go to the web site

Then I see "Hello World"'! !

!ACTestResourceOld class methodsFor: 'strings-Scenario-invalid' stamp: 'topa 5/27/2010 15:04'!
scenarioInvalidOrder

	^
'When I go to the web site
Given I have a web site
Then I see "Hello World"'! !

!ACTestResourceOld class methodsFor: 'strings-Scenario-invalid' stamp: 'topa 5/27/2010 15:04'!
scenarioInvalidSyntax

	^
'Gvien I have a web site
Wehn I go to the web site
Tehn I see "Hello World"'! !

!ACTestResourceOld class methodsFor: 'strings-Scenario-invalid' stamp: 'topa 5/27/2010 15:05'!
scenarioInvalidTrailers

	^
'Given I have a web site
When I go to the web site
Then I see "Hello World"
Yes, This would be awesome.'! !

!ACTestResourceOld class methodsFor: 'strings-then' stamp: 'topa 5/27/2010 14:58'!
then

	^ 'Then I see "Hello World"'! !

!ACTestResourceOld class methodsFor: 'strings-UserStory-valid' stamp: 'topa 5/20/2010 10:07'!
userStory

	^
'A Title
In order to achieve something
As a role
I want to do something.'! !

!ACTestResourceOld class methodsFor: 'strings-UserStory-valid' stamp: 'topa 6/3/2010 13:36'!
userStoryDecompiled

	^
'ACUserStory named: #ATitle
	purpose: ''achieve something''
	role: ''role''
	means: ''do something.''
'! !

!ACTestResourceOld class methodsFor: 'strings-UserStory-invalid' stamp: 'topa 5/20/2010 09:27'!
userStoryInvalidNewlines

	^
'A Title
In order to achieve something

As a role

I want to do something.'! !

!ACTestResourceOld class methodsFor: 'strings-UserStory-invalid' stamp: 'topa 5/20/2010 09:27'!
userStoryInvalidOrder

	^
'A Title
As a role
I want to do something
In order to achieve something.'! !

!ACTestResourceOld class methodsFor: 'strings-UserStory-invalid' stamp: 'topa 5/20/2010 09:28'!
userStoryInvalidSyntax

	^
'A Title
In roder to achieve something
Asa role
I wnat ot do something.'! !

!ACTestResourceOld class methodsFor: 'strings-UserStory-invalid' stamp: 'topa 5/20/2010 09:48'!
userStoryInvalidTrailers

	^
'A Title
In order to achieve something
As a role
I want to do something.

This is cool
'! !

!ACTestResourceOld class methodsFor: 'strings-UserStory-invalid' stamp: 'topa 5/20/2010 09:28'!
userStoryMissingArgs

	^
'A Title
In order to
As a
I want'! !

!ACTestResourceOld class methodsFor: 'strings-UserStory-valid' stamp: 'topa 5/20/2010 09:28'!
userStoryNewlineAfterTitle

	^
'A Title

In order to achieve something
As a role
I want to do something.'! !

!ACTestResourceOld class methodsFor: 'strings-UserStory-valid' stamp: 'topa 5/20/2010 09:29'!
userStorySpacing

	^
'A Title
    In order to achieve something
	As a role
 	 I want to do something.'! !

!ACTestResourceOld class methodsFor: 'strings-when' stamp: 'topa 5/27/2010 14:59'!
when

	^ 'When I go to the web site'! !
